#!/usr/bin/env perl
use WWW::Mechanize;   # libwww-mechanize-perl 
use LWP::UserAgent;   # libwww-perl
use File::Basename;   # perl-modules

# http://www.clusterresources.com/downloads/torque/
# http://www.clusterresources.com/downloads/torque/snapshots/

my $Torque_download_url='http://www.clusterresources.com/downloads/torque/';
my $Torque_beta_download_url='http://www.clusterresources.com/downloads/torque/snapshots/';
my $config_file='/etc/torque-helper/torque-site.conf';
my $release_file='/etc/torque-helper/release';
my $release = "";

sub get_release()
{
    my $fd;
    open $fd,'<', $release_file or return("");
    my $rel = <$fd>;
    $rel =~ s/[^0-9A-z\-\.]//g;
    close($fd);
    return $rel;
}
$release = get_release();

sub config_torque()
{
    my %config_hash = ( usebeta=>'true' );
    
    open my $fd,'<',$config_file or die ($config_file);
    while(<$fd>){
	chop($_);
	$_ =~ s/\#.*$//g;
	$_ =~ s/[\t\s]//g;
	my @parms = split (/=/,$_);
	if ( $#parms == 1 ){
	    $config_hash{$parms[0]}=$parms[1];
	}
    }
    close($fd);
    return %config_hash;
}

# read configurartion file
my %def=config_torque();

my $mech = WWW::Mechanize->new(agent=>'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10 (.NET CLR 3.5.30729)',
			       cookie_jar => {});

# Click - Torque Cluster Scheduler – Download Now 
$mech->get( $Torque_download_url );
die($mech->res()->status_line() . ":" . "follow link.")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );

# table Here
if (( $def{version} =~ /snap/i )||( $def{usebeta} =~ /true/i )){
    $mech->get( $Torque_beta_download_url );
    die($mech->res()->status_line() . ":" . "follow link.")
	unless ( $mech->res()->status_line() =~ /^200 OK/ );
}

my @links;
push(@links,$mech->find_all_links('url_regex' => qr/torque\-[\-0-9A-z\.]+\.tar\.gz$/));

my $n = 0;
my $i = 0;
my $savefilename = 'Torque.tar.gz';
my $version = '';
foreach my $h (@links){
    $i++;
    if (( $i == 1 && $def{version} =~ /new/i )||
	( $h->url() =~ /$def{version}/ )){
	$n = $i;
	$savefilename = basename($h->url());
        $version = $savefilename;
	$version =~  s/(torque\-)([\-0-9A-z\.]+)\.tar\.gz/$2/g;
    }
}

if ( $#links > 0 ){
    if ( $release eq $version ) {
        print $version,"\n";
        exit(0);
    }
    if ( $version =~ /snap/i ){ # beta
	$mech->follow_link('n' => $n,
			   'url_regex' => qr/torque\-[\-0-9A-z\.]+\.tar\.gz$/,
	    ) or die();
	if ( $mech->res()->status_line() =~ /^404 Not Found/ ) {
	    $mech->back();
	    $mech->get(
		$Torque_beta_download_no_script_url . "/" . $savefilename
		);
	}
    }else{                      # release
	$mech->follow_link('n' => $n,
			   'url_regex' => qr/torque\-[\-0-9A-z\.]+\.tar\.gz$/,
	    ) or die();
    }
    if ( $mech->res()->status_line() =~ /^200 OK/ ) {
        open my $fd,'>',$savefilename or die($savefilename);
        print $fd $mech->content();
        close $fd;
        print $version,"\n";
    } else {
        die($mech->res()->status_line() . ":" . $savefilename);
    }

}
exit(0);
